//package hexsweep;
import java.util.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

public class HexSweep{
    public static void main(String[] args){
        HexSweepFrame f = new HexSweepFrame();
        f.setVisible(true);
        f.pack();
    }
}

// EBhE{̃NXB
// ActionListener  JMenuItem ̑I󂯂邽߁B
class HexSweepFrame extends JFrame implements ActionListener
{
    HexSweepPanel hexSweepPanel = new HexSweepPanel();

    private final Dimension defaultMapSize = new Dimension(16,16); // ̃}bvTCYB

    // JMenuItem邽߂ JMenuItem.setActionCommand() ɓnB
    // ͑ɂ̂Ǝvccۂ邪cĉĂ݂悤B
    final String actionString_Image =   "Image ";
    final String actionString_HexSize = "HexSize ";
    final String actionString_Alpha =   "Alpha ";

    JMenuBar menuBar = new JMenuBar();
    JMenu menuNewGame = new JMenu("Simple Game");
    JMenuItem miNewGame_Small = new JMenuItem("small (8x8)");
    JMenuItem miNewGame_Normal = new JMenuItem("normal (16x16)");
    JMenu menuGraphicalGame = new JMenu("Graphical Game");
    JMenu menuHexSize = new JMenu("Hex Size");
    JMenu menuAlpha = new JMenu("Alpha");
    ButtonGroup bgroupHexSize = new ButtonGroup();
    ButtonGroup bgroupAlpha = new ButtonGroup();
    public HexSweepFrame(){
        setTitle("Hex Sweep 1.02");
        addWindowListener(new MyWindowAdapter());
        setResizable(false);
        // j[o[̍쐬B
        setJMenuBar(menuBar);
        menuBar.add(menuNewGame);
        menuNewGame.add(miNewGame_Small);
        menuNewGame.add(miNewGame_Normal);
        miNewGame_Small.addActionListener(this);
        miNewGame_Normal.addActionListener(this);
        // Graphical Game Menu
        HexSweepPanel.setImageFileList(menuGraphicalGame, actionString_Image, this);
        menuBar.add(menuGraphicalGame);
        // wNXTCYύXj[̒ǉB
        menuBar.add(menuHexSize);
        for(int size=16; size<=32; size+=8){
            JRadioButtonMenuItem mi = new JRadioButtonMenuItem(size+"pt", size==16);
            mi.setActionCommand(actionString_HexSize + String.valueOf(size));
            mi.addActionListener(this);
            menuHexSize.add(mi);
            bgroupHexSize.add(mi);
        }
        // At@lύXj[̒ǉB
        menuBar.add(menuAlpha);
        for(int alpha=32; alpha<=224; alpha+=32){
            JRadioButtonMenuItem mi = new JRadioButtonMenuItem(String.valueOf(alpha), alpha==128);
            mi.setActionCommand(actionString_Alpha + String.valueOf(alpha));
            mi.addActionListener(this);
            menuAlpha.add(mi);
            bgroupAlpha.add(mi);
        }
        hexSweepPanel.setMinimumPanelSize(new Dimension(menuBar.getPreferredSize()));
        hexSweepPanel.initGameNoImage(defaultMapSize.width, defaultMapSize.height);
        getContentPane().add(hexSweepPanel);
    }
    // JMenuItem I΂ꂽƂ̏B
    public void actionPerformed(ActionEvent e){
        boolean init=false;
        JMenuItem source = (JMenuItem)e.getSource();
        String command = source.getActionCommand();
        if(source == miNewGame_Small){
            hexSweepPanel.initGameNoImage(8,8);
            init = true;
        }
        else if(source == miNewGame_Normal){
            hexSweepPanel.initGameNoImage(16,16);
            init = true;
        }
        else if(command.startsWith(actionString_Image)){
            // R}h "Image ImageFile.png" Ƃ`ɂȂB
            hexSweepPanel.initGameWithImage(command.substring(actionString_Image.length()));
            init = true;
        }
        else if(command.startsWith(actionString_HexSize)){
            // R}h "HexSize 24" Ƃ`ɂȂB
            // Â炢̕iwNXTCYj̕؂oĂB
            String str = command.substring(actionString_HexSize.length());
            hexSweepPanel.setHexProperty(Integer.parseInt(str), -1);
            init = true;
        }
        else if(command.startsWith(actionString_Alpha)){
            // R}h "Alpha 64" Ƃ`ɂȂB
            // ̕iAt@lj̕؂oĂB
            String str = command.substring(actionString_Alpha.length());
            hexSweepPanel.setHexProperty(-1, Integer.parseInt(str));
        }
        if(init){
            pack();
        }
    }
}

// EBhEƂɃvOI邽߂̃NXB
class MyWindowAdapter extends WindowAdapter
{
    public void windowClosing(WindowEvent e){
        System.exit(0);
    }
}

// wNX}bv\plBQ[̖{́B
// ActionListener  javax.swing.Timer ̌Ăяo󂯂邽߁B
class HexSweepPanel extends JPanel implements MouseListener,ActionListener
{
    private BufferedImage img_offscreen; // ItXN[T[tFCXBAt@l摜B
    private Image img_bg;                // wi摜Bnull ȂwiȂB
    private javax.swing.Timer timer;

    private HexSystem hexSystem = new HexSystem();
    private static final String imageDirectory = "images";
    // ŏ̑傫B܂菬JFrame𖄂߂Ȃ߁B
    // ɃvC[Xe[^X̕\̖̈邪͖B
    // JComponent.setMinimumSize() gĂ킯A
    // ǂ setSize() ̂ŎōŏTCY𔻒fB
    private Dimension minimumPanelSize;
    private HexMap hexMap;
    private String bgImageFile;
    private Point selectedPoint;
    private boolean gameOver;
    private boolean completed;
    private boolean mapVisibled;
    private int playerLife;
    private int restBomb;
    private int sweepCount;
    private int msecCount;
    private Font digitFont;                                  // wNX̒̐̃tHgB
    private Font statusFont = new Font(null, Font.BOLD, 13); // vC[Xe[^X\tHgB
    private int[] alpha_Hex;               // wNX̃At@lXV邽߂̔zB
    private int hexAlpha;                  // ݂̃At@lB
    private int[] alpha_0;                 // At@l=0.
    private int clientWidth,clientHeight;  // ItXN[T[tFCX̑傫B

    public HexSweepPanel(){
        addMouseListener(this);
        timer = new javax.swing.Timer(1000,this);
        setHexProperty(16,128);
    }
    public int getWidth(){ return clientWidth; }
    public int getHeight(){ return clientHeight; }
    // getPreferredSize() I[o[ChȂƉ̂e JFrame ܂Ƃȑ傫ɂȂȂB
    public Dimension getPreferredSize(){
        return new Dimension(getWidth(), getHeight());
    }
    // ItXN[T[tFCX܂߂āA JPanel  d Ȃ邱Ƃ͂ȂB
    public void setMinimumPanelSize(Dimension d){
        minimumPanelSize = d;
    }
    // JPanel ̑傫ݒ肵A܂ItXN[T[tFCX𓯂傫ɂB
    private void setSurfaceSize(int w,int h){
        if(minimumPanelSize != null){
            w = Math.max(w, minimumPanelSize.width);
            h = Math.max(h, minimumPanelSize.height);
        }
        setSize(w,h);
        img_offscreen = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
        Graphics2D g = (Graphics2D)img_offscreen.getGraphics();
        g.setColor(Color.black);
        g.setClip(0,0,img_offscreen.getWidth(this), img_offscreen.getHeight(this));
        clientWidth = w;
        clientHeight = h;
    }
    // wNXɂĂ̐ݒύXB
    // LȒlw肳ĂȂځAyь݂̐ݒƓڂɂĂ͍XVȂB
    // LȒlF size>0 , alpha>=0
    public void setHexProperty(int size,int alpha){
        boolean updateAlpha = false;
        if(alpha>=0 && alpha != hexAlpha){
            hexAlpha = alpha;
            updateAlpha = true;
        }
        if(size>0 && size != hexSystem.getHexWidth()){
            hexSystem.setHexWidth(size);
            alpha_Hex = new int[size*size];
            alpha_0 = new int[size*size];
            SweepTool.intfill(alpha_0,0);
            updateAlpha = true;
            // wNX̃TCYςȏ̓Q[B
            if(hexMap != null){
                if(bgImageFile != null){
                    initGameWithImage(bgImageFile);
                }
                else{
                    initGameNoImage(hexMap.getWidth(), hexMap.getHeight());
                }
            }
            digitFont  = new Font(null, Font.BOLD, size*3/4+1);
        }
        if(updateAlpha){
            SweepTool.intfill(alpha_Hex,hexAlpha);
            if(hexMap != null)
                updateScreen();
        }
    }
    // imageDirectory ɓĂjpgpngt@C̃Xg menu ɉB
    // ȂƂŃj[̂͋CłˁBB
    // headStr ̓ANVR}h̍ŏɕt镶B
    public static int setImageFileList(JMenu menu, String headStr, ActionListener listener){
        File dir = new File(imageDirectory);
        String[] list = dir.list();
        // fBNgꍇAlist=null ɂȂB
        if(list == null)
            return 0;
        int count=0;
        for(int i=0;i<list.length;i++){
            String s = list[i];
            if(s.endsWith(".jpg") || s.endsWith(".png")){
                JMenuItem mi = new JMenuItem(s);
                menu.add(mi);
                mi.setActionCommand(headStr + s);
                mi.addActionListener(listener);
                count++;
            }
        }
        return count;
    }
    // w肳ꂽ摜t@CwiƂAwNX}bv̓Kȑ傫߂ĐVKQ[JnB
    public void initGameWithImage(String fileName){
        img_bg = loadImage(imageDirectory + "/" + fileName);
        if(img_bg == null){
            System.out.println("failed to load image.");
            bgImageFile = null;
            return;
        }
        bgImageFile = fileName;
        int hw = hexSystem.getHexWidth();
        int w = (img_bg.getWidth(this) + hw/2-1)/hw;
        int h = (img_bg.getHeight(this) + hw-1)/hw;
        initGame(w,h);
    }
    public void initGameNoImage(int w,int h){
        img_bg = null;
        bgImageFile = null;
        initGame(w,h);
    }
    private void initGame(int w,int h){
        completed = gameOver = false;
        playerLife = 3;
        sweepCount = 0;
        msecCount = 0;
        mapVisibled = true;
        hexMap = new HexMap(w,h,w*h/6);
        restBomb = hexMap.getBombSum();
        Dimension d = hexSystem.getNeededPixelSize(w,h);
        setSurfaceSize(d.width, d.height+32);
        updateScreen();
    }
    public void paint(Graphics grp){
        Rectangle r = grp.getClipBounds();
        // Iȍĕ`悾ƂȂ Graphics ̌_Ă̂ŒB
        grp.translate(r.x, r.y);
        Rectangle rf;
        //System.out.println("(x,y)="+r.x+","+r.y+"  (w,h)="+r.width+","+r.height);
        Shape oldClip = grp.getClip();
        grp.clipRect(0,0,clientWidth,clientHeight);
        if(img_bg != null){
            // wi摜ƃwNX}bv͂҂v킯ł͂Ȃ̂ŁA[hԂB
            int hexw = hexSystem.getHexWidth();
            int mappw = hexMap.getWidth()*hexw+hexw/2; // }bṽsNZ
            int mapph = hexMap.getHeight()*hexw;
            grp.setColor(Color.black);
            grp.fillRect(mappw-hexw*3/2, 0, hexw*3/2, mapph);
            grp.fillRect(0, mapph-hexw, mappw, hexw);
            grp.drawImage(img_bg, 0, 0, clientWidth-r.x, clientHeight-r.y,
                r.x, r.y, clientWidth, clientHeight, this);
        }
        else{
            grp.setColor(Color.black);
            grp.fillRect(0,0,clientWidth,clientHeight);
        }
        if(img_offscreen != null){
            grp.drawImage(img_offscreen, 0, 0, clientWidth-r.x, clientHeight-r.y,
                r.x, r.y, clientWidth, clientHeight, this);
        }
        grp.setClip(oldClip);
        grp.translate(-r.x, -r.y);
    }
    // X update() ́AʂhԂĂ paint() ̂łB
    // ŃI[oCh paint() Ăяo悤ɂB
    public void update(Graphics g){
        paint(g);
    }
    // ItXN[T[tFCX̓e`悵 repaint() B
    // ȑO̕`lɖSĕ`Ă̂ł炭ptH[}XB
    public void updateScreen(){
        Graphics2D grp2d = (Graphics2D)img_offscreen.getGraphics();
        WritableRaster alphaRaster = img_offscreen.getAlphaRaster();
        Point lp = new Point();
        Point pp = new Point();
        int hexw = hexSystem.getHexWidth();
        int mapw = hexMap.getWidth();
        int maph = hexMap.getHeight();

        grp2d.setColor(Color.darkGray);
        grp2d.fillRect(0,0,clientWidth,clientHeight);
        // }bvŜ`BЂƂ̃wNX`ʃ\bhɂĂȂB
        for(int y=0;y<maph;y++){
            for(int x=0;x<mapw;x++){
                lp.x = x;
                lp.y = y;
                hexSystem.getGraphicXY(pp,lp);
                int state = hexMap.state[x][y];
                grp2d.setColor(Color.gray);
                if(state == 0){
                    drawDefaultRect(grp2d, pp.x, pp.y, hexw-1, hexw-1);
                    drawMarker(grp2d, pp.x, pp.y, hexw-1, hexw-1, hexMap.mark[x][y]);
                }
                else if(state == 1){
                    drawCheckedRect(grp2d, pp.x, pp.y, hexw-1, hexw-1);
                    if(hexMap.bomb[x][y]){
                        grp2d.setColor(Color.red);
                        grp2d.fillRect(pp.x+2, pp.y+2, hexw-5, hexw-5);
                    }else{
                        grp2d.setColor(Color.white);
                        grp2d.setFont(digitFont);
                        alphaRaster.setPixels(pp.x+1, pp.y+1, hexw-3, hexw-3, alpha_Hex);
                        if(hexMap.bombCount[x][y] > 0)
                            drawStringInRect(grp2d, String.valueOf(hexMap.bombCount[x][y]), pp.x, pp.y-3, hexw-1, hexw-1);
                        //else
                        //    alphaRaster.setPixels(pp.x, pp.y, hexw, hexw, alpha_0);
                    }
                }
            }
        }
        // vC[wNX̏Ń}EX{^Ă炻B
        if(selectedPoint != null){
            grp2d.setColor(Color.gray);
            hexSystem.getGraphicXY(pp,selectedPoint);
            drawSelectedRect(grp2d, pp.x, pp.y, hexw-1, hexw-1);
        }
        if(gameOver || completed){
            String msg;
            int fontSize = clientWidth/8;
            Color fontColor;
            if(gameOver){
                msg = "GAME OVER";
                fontColor = Color.yellow;
            }else{
                msg = "COMPLETED!";
                fontColor = Color.green;
            }
            // ̕`TCYm邽߂ɃtHgݒ肵Ă邪A
            // drawShowyString()̓eɈvȂƂȂ̂͂܂B
            grp2d.setFont(new Font(null, Font.BOLD, fontSize));
            Point p = getPointToCenteringStringInRect(grp2d,msg,0,0,mapw*hexw,maph*hexw);
            drawShowyString(grp2d, msg, p.x, p.y, fontSize, fontColor);
        }
        drawPlayerStatus(grp2d, 8, maph*hexw);
        if(!mapVisibled){
            // }bṽ̕At@NAđfʂɂB
            int w = mapw*hexw + hexw/2;
            int h = maph*hexw;
            SweepTool.fillRaster(alphaRaster,0,0,w,h,0);
        }
        repaint();
    }
    // XC[ṽwNX`悷B
    private void drawDefaultRect(Graphics2D g,int x,int y,int w,int h){
        g.fill3DRect(x,y,w,h,true);
    }
    // XC[vς݂̃wNX`悷B
    private void drawCheckedRect(Graphics2D g,int x,int y,int w,int h){
        g.fill3DRect(x,y,w,h,false);
    }
    // }EX{^ꂽԂ̃wNX`悷B
    private void drawSelectedRect(Graphics2D g,int x,int y,int w,int h){
        g.fillRect(x,y,w,h);
    }
    // vC[wNXɕt}[J`悷B
    private void drawMarker(Graphics2D g,int x,int y,int w,int h,int mark){
        if(mark == 1){
            g.setColor(Color.red);
            g.setFont(digitFont);
            drawStringInRect(g, "X", x, y-3, w-1, h-1);
        }
    }
    // vC[̃CtȂǂ`悷BfUC͌ڂœKɌ߂B
    private void drawPlayerStatus(Graphics2D g,int x,int y){
        g.setColor(Color.darkGray);
        g.fillRect(x,y,224,32);
        g.setFont(statusFont);
        g.setColor(Color.white);
        int charY = y+statusFont.getSize();
        g.drawString("Life", x, charY);
        g.drawString("Rest:"+restBomb, x+80, charY);
        // b\͂Ɛ`BDecimalFormatĝ傰ȘbB
        int sec = msecCount/1000;
        String secStr = String.valueOf(sec%60);
        if(sec%60 < 10)
            secStr = "0"+secStr;
        g.drawString(sec/60+":"+secStr, x+160, charY);
        g.setColor(Color.orange);
        for(int i=0;i<playerLife;i++){
            g.fillRect(x+32+i*10, y+2, 8, 12);
        }
    }
    // `̒ɕ`B
    void drawStringInRect(Graphics2D g,String str,int x1,int y1,int w,int h){
        Point p = getPointToCenteringStringInRect(g,str,x1,y1,w,h);
        g.drawString(str, p.x, p.y);
    }
    // `̒ɕ`ꍇ̍W߂ĕԂB
    Point getPointToCenteringStringInRect(Graphics2D g,String str,int x1,int y1,int w,int h){
        Rectangle2D rect = g.getFont().getStringBounds(str, g.getFontRenderContext());
        int fontW = (int)rect.getWidth();
        int fontH = (int)rect.getHeight();
        int marginX = w - fontW;
        int marginY = h - fontH;
        if(marginX < 0)
            marginX = 0;
        if(marginY < 0)
            marginY = 0;
        return new Point(x1+marginX/2, y1+fontH+marginY/2);
    }
    // Game Over Ȃǂ̒PȃbZ[W\邽߂̏ꂽ`悷B
    void drawShowyString(Graphics2D g,String str,int x,int y,int fontSize,Color charColor){
        final int shadeX=4, shadeY=4, edgeWidth=1;
        Font font1 = new Font(null, Font.BOLD, fontSize);
        g.setFont(font1);
        g.setColor(new Color(0,0,0,128));
        g.drawString(str,x+shadeX,y+shadeY);
        g.setColor(new Color(0,0,0));
        g.drawString(str,x-edgeWidth,y);
        g.drawString(str,x+edgeWidth,y);
        g.setColor(charColor);
        g.drawString(str,x,y);
    }
    public void mouseClicked(MouseEvent e){
	/* }EXNbNꂽ̏ */
    }

    public void mouseEntered(MouseEvent e){
	/* }EXR|[lg̏ɏ̏ */
    }

    public void mouseExited(MouseEvent e){
	/* }EXR|[lg̊Oɏȍ */
    }

    public void mousePressed(MouseEvent e){
	/* }EXꂽ̏ */
        if(gameOver)
            return;
        if(completed){
            // Xe[WNAɔwi摜Ȃ΁A}bvB
            if(img_bg!=null && mapVisibled){
                mapVisibled = false;
                updateScreen();
            }
            return;
        }
        Point lp=new Point(), gp=new Point();
        gp.x = e.getX();
        gp.y = e.getY();
        hexSystem.getLogicalXY(lp,gp);
        if(hexMap.isInternal(lp)){
            // ɃXC[vς݂̃wNXɂĂ͍̂Ƃ鏈͖B
            if(hexMap.state[lp.x][lp.y] != 0){
                return;
            }
            // {^ȂwNXIBE{^Ȃ}[LOB
            if(e.getModifiers() == InputEvent.BUTTON1_MASK){
                selectedPoint = lp;
            }
            else{
                int mark = hexMap.mark[lp.x][lp.y];
                if(mark == 0){
                    restBomb--;
                }else{
                    restBomb++;
                }
                mark ^= 1;
                hexMap.mark[lp.x][lp.y] = mark;
            }
        }
        updateScreen();
    }

    public void mouseReleased(MouseEvent e){
	/* }EXꂽAꂽ̏ */
        if(selectedPoint == null)
            return;
        Point lp=new Point(), gp=new Point();
        gp.x = e.getX();
        gp.y = e.getY();
        hexSystem.getLogicalXY(lp,gp);
        if(selectedPoint.equals(lp)){
            hexMap.state[lp.x][lp.y] = 1;
            // Q[Jnŏ̑IȂ^C}[JnȂǂB
            if(sweepCount == 0){
                // ŏ̃wNXɒn瑼̏ɈڂāAȂƂɂB
                if(hexMap.bomb[lp.x][lp.y]){
                    hexMap.setBombAtRandom(1);
                    hexMap.bomb[lp.x][lp.y] = false;
                }
                timer.start();
            }
            if(hexMap.bomb[lp.x][lp.y]){
                playerLife--;
                if(hexMap.mark[lp.x][lp.y] == 0)
                    restBomb--;
                if(playerLife == 0)
                    gameOver = true;
            }else{
                hexMap.bombCount[lp.x][lp.y] = getNeighborBombCount(lp);
                if(hexMap.bombCount[lp.x][lp.y] == 0){
                    sweepContinuous(lp);
                }
                completed = isCompleted();
            }
            sweepCount++;
        }
        if(gameOver || completed)
            timer.stop();
        selectedPoint = null;
        updateScreen();
    }
    // Timer CxgpB
    public void actionPerformed(ActionEvent e){
        msecCount += timer.getDelay();
        updateScreen();
    }

    // p ̎ӂUփNXɂn̐𓾂B
    private int getNeighborBombCount(Point p){
        int count=0;
        Point[] plist = hexSystem.getNextXY(p);
        for(int i=0;i<plist.length;i++){
            Point np = plist[i];
            if(hexMap.isInternal(np) && hexMap.bomb[np.x][np.y]){
                count++;
            }
        }
        return count;
    }

    // IwNX̎͂ɒnΎIɘAXC[vB
    private void sweepContinuous(Point p){
        int count;
        Point[] plist = hexSystem.getNextXY(p);
        for(int i=0;i<plist.length;i++){
            Point np = plist[i];
            if(hexMap.isInternal(np) && hexMap.state[np.x][np.y]==0){
                hexMap.state[np.x][np.y] = 1;
                hexMap.bombCount[np.x][np.y] = count = getNeighborBombCount(np);
                if(count == 0){
                    sweepContinuous(np);
                }
            }
        }
    }

    // XC[v͏IH
    private boolean isCompleted(){
        return hexMap.isAllSweeped();
    }

    // JVRPGiJavaō肩RPGj JVGraphics.java RsyB
    Image loadImage(String file){
        // Avbĝ݂ŉ^pꍇ͂̈sł悢B
        //return getImage(getDocumentBase(),file);
        URL imageURL = getClass().getResource(file);
        Image image=null;
        try{
            if(imageURL.getContent() == null)
                System.out.println("file not found ("+file+").");
            //System.out.println(imageURL.toString());
            image = createImage((java.awt.image.ImageProducer)imageURL.getContent());
            // MediaTrackergȂƁAǂݍ݂IOɎ̏n܂Ă܂B
            MediaTracker mt = new MediaTracker(this);
            mt.addImage(image, 0);
            mt.checkAll(true);
            try{
                mt.waitForID(0);
            }catch(InterruptedException e){
                System.out.println("file exists but failed to load image ("+file+").");
            }
        }catch(IOException e){
        }
        return image;
    }
}

// փNXɊւWȂǂ܂Ƃ߂NXB
// ꉞǒn헪̃wNXƌ݊B
class HexSystem{
    private static final int nextX[][]={{0,1,1,1,0,-1},{-1,0,1,0,-1,-1}};
    private static final int nextY[] = {-1,-1,0,1,1,0};
    private int hexWidth;
    public HexSystem(){
    }
    public void setHexWidth(int w){
        hexWidth = w;
    }
    public int getHexWidth(){
        return hexWidth;
    }
    // (w,h)̑傫̃}bv`悷邽߂ɕKvȃsNZ̈̑傫𓾂B
    public Dimension getNeededPixelSize(int w,int h){
        return new Dimension(w*hexWidth+hexWidth/2, h*hexWidth);
    }
    // _W lp 畨W gp 𓾂B
    public void getGraphicXY(Point gp,Point lp){
        gp.x = lp.x*hexWidth + hexWidth*(1-lp.y%2)/2;
        gp.y = lp.y*hexWidth;
    }
    // W gp _W lp 𓾂B
    public void getLogicalXY(Point lp,Point gp){
        lp.y = gp.y/hexWidth;
        if(lp.y%2 == 1){
            lp.x = gp.x/hexWidth;
        }else{
            lp.x = (gp.x-hexWidth/2)/hexWidth;
        }
    }
    // center ̎͂UփNX̍WXg𐶐B
    public static Point[] getNextXY(Point center){
        Point[] plist = new Point[6];
        for(int i=0;i<6;i++){
            Point np = new Point();
            np.x = center.x + nextX[center.y%2][i];
            np.y = center.y + nextY[i];
            plist[i] = np;
        }
        return plist;
    }
}

// }bv̏Ԃi[NXB
// state  mark ͏̊ĝ߂ int ɂȂĂ邪Agꍇ
// 0Ƃ1Ȃǂ̃}WbNio[Ē萔ɂׂł낤B
class HexMap
{
    public int state[][];     // XC[v󋵁B0:XC[v 1:XC[vς
    public int bombCount[][]; // ͂̒nB
    public boolean bomb[][];  // n邩H
    public int mark[][];      // vC[t}[N̎ށB0:}[N 1:n}[N
    private int width,height;         // 傫Bꉞ private
    // 傫ƒnݒuw肷B
    // 傫ɑ΂ĒnƁAԂ薳[vɂȂ肷̂ŒӁB
    public HexMap(int w,int h,int bombset){
        state = new int[w][h];
        bombCount = new int[w][h];
        bomb = new boolean[w][h];
        mark = new int[w][h];
        width = w;
        height = h;
        setBombAtRandom(bombset);
    }
    public int getWidth(){ return width; }
    public int getHeight(){ return height; }
    public boolean isInternal(int x,int y){
        return (x>=0 && y>=0 && x<width && y<height);
    }
    public boolean isInternal(Point p){
        return isInternal(p.x, p.y);
    }
    // count ̒nVɐݒuBȂȂɎ蔲ŌB
    public void setBombAtRandom(int count){
        // Java  Random ̓ftHgŌݎV[hƂB
        Random rand = new Random();
        for(int i=0;i<count;){
            int x = rand.nextInt(width);
            int y = rand.nextInt(height);
            if(!bomb[x][y]){
                bomb[x][y] = true;
                i++;
            }
        }
    }
    // n̍vB
    public int getBombSum(){
        int count=0;
        for(int y=0;y<height;y++){
            for(int x=0;x<width;x++){
                if(bomb[x][y])
                    count++;
            }
        }
        return count;
    }
    // nȊOSăXC[vH
    public boolean isAllSweeped(){
        for(int y=0;y<height;y++){
            for(int x=0;x<width;x++){
                // XC[v̒nт𔭌B
                if(!bomb[x][y] && state[x][y]==0)
                    return false;
            }
        }
        return true;
    }
}

// static ɂł郁\bhuĂNXB
class SweepTool{
    // memset()̑BJava FAQ RsyB
    public static void bytefill(byte[] array, byte value) {
        int len = array.length;
        if (len > 0)
            array[0] = value;
        for (int i = 1; i < len; i += i)
           System.arraycopy( array, 0, array, i,
                ((len - i) < i) ? (len - i) : i);
    }
    // Java ɂ template ̂ŏ̃RsyB1.4  Genericity 炵B
    public static void intfill(int[] array, int value) {
        int len = array.length;
        if (len > 0)
            array[0] = value;
        for (int i = 1; i < len; i += i)
           System.arraycopy( array, 0, array, i,
                ((len - i) < i) ? (len - i) : i);
    }
    // WritableRaster ̋`̈ value Ŗ߂B
    public static void fillRaster(WritableRaster raster,int x,int y,int w,int h,int value){
        // Ȉꎞ̈xgēhԂB
        final int tmpw=32,tmph=32;
        final int[] tmpAlpha = new int[tmpw*tmph];
        SweepTool.intfill(tmpAlpha,value);
        for(int bx=0; bx < (w+tmpw-1)/tmpw; bx++){
            for(int by=0; by < (h+tmph-1)/tmph; by++){
                int px = bx*tmpw;
                int py = by*tmph;
                // [hԂƂ͒[̕߂B
                int fillw = tmpw > w-px ? w-px : tmpw;
                int fillh = tmph > h-py ? h-py : tmph;
                raster.setPixels(x+px, y+py, fillw, fillh, tmpAlpha);
            }
        }
    }
}

